#pragma once

#include <iostream>
#include <string>
#include <map>

using namespace std;

class Line;
class Stop;

class JGP
{
	map<std::string, Line*> lines;
	map<int, Stop*> stops;
	static JGP* instance;
	JGP() {}
public:
	static JGP* getInstance() {
		if (instance == nullptr) {
			instance = new JGP();
		}
		return instance;
	}
	Stop* operator[](int i) {
		if (stops.find(i) == stops.end()) return nullptr;
		else return stops[i];
	}
	Line* operator[](string l) {
		if (lines.find(l) == lines.end()) return nullptr;
		else return lines[l];
	}
	void addStop(Stop* stop);
	void parse(std::string directory);
	friend std::ostream& operator<<(std::ostream& ot, JGP& jgp);
};

