#pragma once

#include <iostream>
#include <string>
#include <map>

#include "Line.h"

class JGP
{
	map<string, Line*> lines;
	map<int, Stop*> stops;

	static JGP* instance;
	JGP() {}
public:
	static JGP& getInstance() {
		if (instance == nullptr) {
			instance = new JGP();
		}
		return *instance;
	}
	static void deleteInstance();

	void parse(std::string directory);

	Stop* operator[](int i) {
		if (stops.find(i) == stops.end()) return nullptr;
		else return stops[i];
	}

	Line* operator[](string s) {
		if (lines.find(s) == lines.end()) return nullptr;
		else return lines[s];
	}

	void addStop(Stop* s);

	map<pair<Line*, Line*>, int> allPairs(int min = -1)const;
	vector<Stop*> stopsWithMostLines()const;
	void exportGraph(string file);

	friend std::ostream& operator<<(std::ostream& ot, const JGP& jgp);
};

