#pragma once

#include <string>
#include <iostream>
#include <vector>
#include <set>

using namespace std;

class Stop;

class Line
{
	string name, from, to;
	vector<Stop*> stops;
public:
	Line(string name, string from, string to) {
		this->name = name;
		this->from = from;
		this->to = to;
	}
	string getName()const { return name; }

	auto begin()const { return stops.begin(); }
	auto end()const { return stops.end(); }

	void parse(string fileName);

	set<Line*> commonStopsWith()const;
	vector<Stop*> edgeStops()const;
	pair<Line*, int> mostCommonStopsWith()const;

	friend ostream& operator<<(ostream& ot, const Line& l);
};

