#pragma once

#include <iostream>
#include <string>
#include <vector>

class Line;

using namespace std;

class Stop
{
	string name;
	int number;
	vector<Line*> lines;
	double x, y;
	int zone;
public:
	Stop(string name, int number, vector<Line*> lines, double x, double y, int zone) {
		this->name = name;
		this->number = number;
		this->lines = lines;
		this->x = x;
		this->y = y;
		this->zone = zone;
	}

	auto begin() const { return lines.begin(); }
	auto end() const { return lines.end(); }

	int getNumber()const { return number; }
	int numberOfLines()const { return lines.size(); }
	string getName()const { return name; }
	double getX()const { return x; }
	double getY()const { return y; }

	friend ostream& operator<<(ostream& ot, const Stop& s);
};

