#include <iostream>
#include "JGP.h"
#include "Line.h"
#include "Stop.h"

using namespace std;

int main() {

	string directory = "C:\\Users\\Ziza\\Desktop\\podaci\\";

	JGP& jgp = JGP::getInstance();
	jgp.parse(directory);

	cout << jgp << endl;

	Line& l = *jgp["74"];

	cout << endl << endl << "Zadatak 4.a: Zajednicka stajalista sa linijom 74 imaju sledece linije: ";
	for (auto iter : l.commonStopsWith()) cout << iter->getName() << "  ";

	cout << endl << endl << "Zadatak 4.b: Ivicna (najsevernije, najistocnije, najjuznije i najzapadnije) stajalista linije 74 su: " << endl;
	for (auto iter : l.edgeStops()) cout << "\t" << *iter;

	pair<Line*, int> theMost = l.mostCommonStopsWith();
	cout << endl << endl << "Zadatak 4.c: Linija 74 ima najvise zajednickih stajalista sa linijom "
		<< theMost.first->getName() << " i to " << theMost.second << " stajalista" << endl;

	map<pair<Line*, Line*>, int> allPairs = jgp.allPairs(5);
	cout << endl << endl << "Zadatak 5.a: Svi parovi linija sa najmanje 5 zajednickih stajalista: " << endl;
	for (auto iter : allPairs) cout << "\t" << iter.first.first->getName() << " i " << iter.first.second->getName()
		<< " imaju " << iter.second << " zajednickih stajalista" << endl;

	cout << endl << endl << "Zadatak 5.b: Stajalista kroz koja prolazi najveci broj linija: " << endl;
	for (auto iter : jgp.stopsWithMostLines()) cout << "\t" << *iter;

	cout << endl << "Zadatak 6: Eksportovanje grafa stajalista u graph.gml fajl..." << endl;
	jgp.exportGraph(directory + "graph.gml");
	cout << "Graf je uspesno eksportovan u graph.gml fajl!" << endl << endl;

	JGP::deleteInstance();

	system("pause");
	return 0;
}

